=== debian/changelog ===
scotch (7.0.10-6) unstable; urgency=medium

  * reinstate metis compatibility links (metis.h, libmetis.so)
    provided by libscotchmetis-dev. libmetis.so is linked to
    libscotchmetisv5.so (not scotchmetisv3)
    To use _64*-bit metis emulation, we recommend configuring to
    access libscotchmetisv5_64*.so directly (or _v3).

 -- Drew Parsons <dparsons@debian.org>  Sun, 30 Nov 2025 13:01:03 +0100

scotch (7.0.10-5) unstable; urgency=medium

  * debian/rules: fix debug code for ppc64el

 -- Drew Parsons <dparsons@debian.org>  Sat, 29 Nov 2025 13:05:26 +0100

scotch (7.0.10-4) unstable; urgency=medium

  * ppc64el: ppc64_cpu --smt returns 255 (with no SMT) so guard with
    /bin/true to prevent it giving build failure
  * debian/tests: build tests with -DCOMMON_PTHREAD (and other pthread
    flags) to enable test_common_thread to pass on ppc64el.
    Reenable test_common_thread on ppc64el. See Bug#1121516
    (upstream Issue#57)

 -- Drew Parsons <dparsons@debian.org>  Sat, 29 Nov 2025 11:41:03 +0100

scotch (7.0.10-3) unstable; urgency=medium

  * ppc64el: skip test_common_thread and run separately to debug,
    and report system information (ppc64_cpu --smt, etc)
    for Bug#1121516. Build-Depends: powerpc-ibm-utils [ppc64el]

 -- Drew Parsons <dparsons@debian.org>  Sat, 29 Nov 2025 01:42:25 +0100

scotch (7.0.10-2) unstable; urgency=medium

  * Standards-Version: 4.7.2
  * new soname transition #1121012

 -- Drew Parsons <dparsons@debian.org>  Thu, 20 Nov 2025 12:26:20 +0100

scotch (7.0.10-1exp5) experimental; urgency=medium

  * debian patch scotchmetis_optional.patch makes installation of
    scotchmetis and scotchparmetis optional in the scotch cmake config
    files
  * reenable ptscotch tests (openmpi/pmix are now fixed).
    Drop skip_ptscotch_tests.patch. Closes: #1120413.

 -- Drew Parsons <dparsons@debian.org>  Sat, 15 Nov 2025 19:15:20 +0100

scotch (7.0.10-1exp4) experimental; urgency=medium

  * debian patch skip_ptscotch_tests.patch applies ENABLE_PTSCOTCH_TESTS
    to allow disabling ptscotch tests, which broke with pmix 5.0.9.
    Chroots with only a loopback lo interface are affected (no remote
    interface), i.e. debian buildds. debci has remote interfaces and
    continues to pass.
    See Bugs#1120413, #1120424, pmix upstream issue#3717.

 -- Drew Parsons <dparsons@debian.org>  Sun, 09 Nov 2025 11:19:30 +0100

scotch (7.0.10-1exp3) experimental; urgency=medium

  * fix dependencies of lib*scotch-64*-dev packages
    libptscotch-64i-dev Depends: libptscotch-64i-7.0, libscotch-64i-dev
    libptscotcherr-dev Depends: libscotch-64-dev, etc

 -- Drew Parsons <dparsons@debian.org>  Sat, 08 Nov 2025 10:03:39 +0100

scotch (7.0.10-1exp2) experimental; urgency=medium

  * debian patch build-shared-library-soname.patch:
    apply SCOTCH_SONAME_SUFFIX to ptesmumps.
    libptscotch-64* installs libptesmumps_64*

 -- Drew Parsons <dparsons@debian.org>  Wed, 05 Nov 2025 00:41:40 +0100

scotch (7.0.10-1exp1) experimental; urgency=medium

  * New upstream release

 -- Drew Parsons <dparsons@debian.org>  Sat, 04 Oct 2025 13:43:31 +0200

scotch (7.0.9-1exp4) experimental; urgency=medium

  * libscotchparmetis-dev.links: restore link from default
    libptscotchparmetisv3.so to libparmetis.so
    To use _64*-bit parmetis emulation, we recommend configuring to
    access libptscotchparmetisv3_64*.so directly.
  * configure LIBSCOTCHERR=scotcherr and LIBPTSCOTCHERR=ptscotcherr
    to link libraries to libscotcherr.so or libptscotcherr.so
  * fix Replaces: syntax in debian/control

 -- Drew Parsons <dparsons@debian.org>  Wed, 10 Sep 2025 03:54:50 +0200

scotch (7.0.9-1exp3) experimental; urgency=medium

  * reinstate libscotchparmetis-dev.links to link
    /usr/include/parmetis to /usr/include/scotch (for parmetis.h)
  * scotch 7.0.9 builds with C23 (gcc-15). Closes: #1097860.

 -- Drew Parsons <dparsons@debian.org>  Tue, 09 Sep 2025 17:11:54 +0200

scotch (7.0.9-1exp2) experimental; urgency=medium

  * new release provides ParMETIS_V3_Mesh2Dual. Closes: #653647.
  * add test skip rules to debian/tests/test-scotch and skip
    test_common_random on 32-bit arches with 64-bit integers (_64i)

 -- Drew Parsons <dparsons@debian.org>  Wed, 03 Sep 2025 18:05:31 +0200
