=== debian/tests/control ===
Tests: test-scotch, test-ptscotch,
 test-scotch-64, test-ptscotch-64,
 test-scotch-64i, test-ptscotch-64i
Depends: @, @builddeps@, powerpc-ibm-utils [ppc64el]
Restrictions: allow-stderr
